-- ============================================================
--   Table: NINVENTAR                                          
-- ============================================================
create table NINVENTAR
(
    ID_INVENTAR  NUMBER                 not null,
    OPIS         VARCHAR2(100)          not null,
    SLO          VARCHAR2(100)          null    ,
    CRO          VARCHAR2(100)          null    ,
    GB           VARCHAR2(100)          null    ,
    D            VARCHAR2(100)          null    ,
    I            VARCHAR2(100)          null    ,
    F            VARCHAR2(100)          null    ,
    constraint PK_NINVENTAR primary key (ID_INVENTAR)
);

-- ============================================================
--   Table: INVENTAR                                           
-- ============================================================
create table INVENTAR
(
    ID_INV       NUMBER                 not null,
    ID_INVENTAR  NUMBER                 not null,
    ID_PLOVILA   NUMBER                 not null,
    KOLICINA     NUMBER                 not null,
    USER_CREATE  VARCHAR2(10)           not null,
    USER_CHANGE  VARCHAR2(10)           null    ,
    DATE_CREATE  DATE                   not null,
    DATE_CHANGE  DATE                   null    ,
    constraint PK_INVENTAR primary key (ID_INV)
);

-- ============================================================
--   Index: RELATION_33_FK                                     
-- ============================================================
create index RELATION_33_FK on INVENTAR (ID_INVENTAR asc);

alter table INVENTAR
    add constraint FK_INVENTAR_RELATION__NINVENTA foreign key  (ID_INVENTAR)
       references NINVENTAR (ID_INVENTAR);

create table NINVENTARGRUPA
(
     ID_INVENTARGRUPA  NUMBER                 not null,
     OPIS         VARCHAR2(100)          not null,
     SLO          VARCHAR2(100)          null    ,
     CRO          VARCHAR2(100)          null    ,
     GB           VARCHAR2(100)          null    ,
     D            VARCHAR2(100)          null    ,
     I            VARCHAR2(100)          null    ,
     F            VARCHAR2(100)          null    ,
     constraint PK_NINVENTARGRUPA primary key (ID_INVENTARGRUPA)
);

ALTER TABLE NINVENTAR
  ADD ID_INVENTARGRUPA NUMBER;

ALTER TABLE NINVENTAR
  MODIFY ID_INVENTARGRUPA NUMBER NOT NULL;

INSERT INTO DATA_KEYS ( IZVOR_TABELA, IZVOR_POLJE, IME_TABELE, IME_POLJA, TIP_POLJA, POLJE_OPIS, TIP_OPIS ) VALUES ( 'NINVENTAR', 'ID_INVENTARGRUPA', 'NINVENTARGRUPA', 'ID_INVENTARGRUPA', 'I', 'OPIS', 'S'); 

INSERT INTO PRINT_MODULI ( MODULE_ID, OPIS, CR_FILE ) VALUES ( 'INVENTAR', 'Inventarna lista', 'Inventar.rpt'); 

INSERT INTO PRINT_PREVOD ( ID_PRINTPREVOD, MODULE_ID, JEZIK, CR_FILE, POLJEJEZIK, KODA_JEZIKA ) VALUES ( 191, 'INVENTAR', 'Hrvatski', 'InventarCRO.rpt', NULL, 'CRO'); 
INSERT INTO PRINT_PREVOD ( ID_PRINTPREVOD, MODULE_ID, JEZIK, CR_FILE, POLJEJEZIK, KODA_JEZIKA ) VALUES ( 192, 'INVENTAR', 'Slovenski', 'InventarSLO.rpt', NULL, 'SLO'); 
INSERT INTO PRINT_PREVOD ( ID_PRINTPREVOD, MODULE_ID, JEZIK, CR_FILE, POLJEJEZIK, KODA_JEZIKA ) VALUES ( 193, 'INVENTAR', 'Engleski', 'InventarENG.rpt', NULL, 'ENG'); 
INSERT INTO PRINT_PREVOD ( ID_PRINTPREVOD, MODULE_ID, JEZIK, CR_FILE, POLJEJEZIK, KODA_JEZIKA ) VALUES ( 194, 'INVENTAR', 'Njemaki', 'InventarNE.rpt', NULL, 'ENG'); 
INSERT INTO PRINT_PREVOD ( ID_PRINTPREVOD, MODULE_ID, JEZIK, CR_FILE, POLJEJEZIK, KODA_JEZIKA ) VALUES ( 195, 'INVENTAR', 'Talijanski', 'InventarIT.rpt', NULL, 'ITL'); 


insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (142, SYSDATE, '5.5', 62, 'INVENTAR');