INSERT INTO RIGHTS (NUSER, PRAVICA) 
SELECT NUSER, 'WORK_ORDER_CHANGE_DATE'
FROM RIGHTS WHERE PRAVICA = 'STORNO_DN';

INSERT INTO RIGHTS (NUSER, PRAVICA) 
SELECT NUSER, 'STORNO_DN'
FROM NUSER WHERE AKT = 'Y' AND NUSER NOT IN (SELECT NUSER FROM RIGHTS WHERE PRAVICA = 'STORNO_DN');

ALTER TABLE FB_TABLE
MODIFY ID_FB_LOCATION NULL;

ALTER TABLE FB_ORDER
ADD ID_FB_LOCATION NUMBER;

UPDATE FB_ORDER FO
SET FO.ID_FB_LOCATION = (SELECT FT.ID_FB_LOCATION FROM FB_TABLE FT WHERE FT.ID_FB_TABLE = FO.ID_FB_TABLE)
WHERE FO.ID_FB_LOCATION IS NULL;

ALTER TABLE FB_TABLE
ADD NNLOCATION_ID NUMBER;

UPDATE FB_TABLE FT
SET FT.NNLOCATION_ID = (SELECT FB.NNLOCATION_ID FROM FB_LOCATION FB WHERE FB.ID_FB_LOCATION = FT.ID_FB_LOCATION)
WHERE FT.NNLOCATION_ID IS NULL;

ALTER TABLE S_OBRACUN
ADD UNIT_AMOUNT_DISCOUNT NUMBER;

DROP VIEW V_FB_ORDER;

CREATE OR REPLACE VIEW V_FB_ORDER
AS (
SELECT FO.ID_FB_ORDER, FO.ORDER_NUMBER, FO.ID_FB_TABLE, FO.ID_LASTNIKA, FO.ID_STATUS, FO.DATE_FROM, FO.DATE_TO, FO."COMMENT", FO.DATE_CREATED, FO.USER_CREATED, FO.ID_FB_RESERVATION, FO.ID_FB_LOCATION, 
FT.DESCRIPTION AS TABLE_DESCRIPTION, FL.DESCRIPTION AS AREA_DESCRIPTION, FOS.DESCRIPTION AS STATUS_DESCRIPTION, FOS.COLOR AS STATUS_COLOR, FOS.TEXT_COLOR AS STATUS_TEXT_COLOR, U.USER_ AS USER_NAME,
KUP.YACHT_CLUB_ID AS KUPCI_YACHT_CLUB_ID,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KUP.IME || ' ' || KUP.PRIIMEK) ELSE (KUP.PRIIMEK || ' ' || KUP.IME) END) AS OWNER
FROM FB_ORDER FO
LEFT OUTER JOIN FB_TABLE FT ON FT.ID_FB_TABLE = FO.ID_FB_TABLE
LEFT OUTER JOIN FB_LOCATION FL ON FL.ID_FB_LOCATION = FO.ID_FB_LOCATION
LEFT OUTER JOIN FB_ORDER_STATUS FOS ON FOS.ID_FB_ORDER_STATUS = FO.ID_STATUS
LEFT OUTER JOIN NUSER U ON U.NUSER = FO.USER_CREATED
LEFT OUTER JOIN KUPCI KUP ON KUP.ID = FO.ID_LASTNIKA
);

DROP VIEW V_FB_TABLE;

CREATE OR REPLACE VIEW V_FB_TABLE AS (
SELECT FT.ID_FB_TABLE, FT.ID_FB_LOCATION, FT.DESCRIPTION, FT.CAPACITY, FT.ACTIVE, FT.NNLOCATION_ID AS NNLOCATION_ID, FL.DESCRIPTION AS LOCATION_DESCRIPTION
FROM FB_TABLE FT
LEFT OUTER JOIN FB_LOCATION FL ON FL.ID_FB_LOCATION = FT.ID_FB_LOCATION
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1666, SYSDATE, '5.5', 1586, 'FB')
;