ALTER TABLE VOUCHER_TYPE
ADD VALIDITY_PERIOD NUMBER;

ALTER TABLE S_ARTIKLI
ADD ID_VOUCHER_TYPE NUMBER;

ALTER TABLE FB_ORDER_DETAIL
ADD CARD_NUMBER VARCHAR2(50 CHAR);

ALTER TABLE S_OBRACUN
ADD ID_VOUCHER NUMBER;

ALTER TABLE NNCARDS
ADD VOUCHER_TYPE NUMBER;

ALTER TABLE MONEY
ADD ID_VOUCHER NUMBER;

CREATE INDEX IX_MONEY_ID_VOUCHER ON MONEY(ID_VOUCHER);

ALTER TABLE VOUCHER
DROP COLUMN USED_AMOUNT;

CREATE OR REPLACE VIEW V_VOUCHER_MONEY AS (
  SELECT M.ID_VOUCHER, COALESCE(SUM(M.ZNESEK_SIT), 0) AS USED_AMOUNT FROM MONEY M
  WHERE ID_VOUCHER IS NOT NULL
  GROUP BY M.ID_VOUCHER
);

DROP VIEW V_VOUCHER;

CREATE OR REPLACE VIEW V_VOUCHER AS (
  SELECT V.ID_VOUCHER, V.ID_TYPE, V.ID_LASTNIKA, V.UNIQUE_NUMBER, V.DATE_CREATED, V.EXPIRY_DATE, V.AMOUNT, V.NNLOCATION_ID, V.NOTE, V.ACTIVE, VT.DESCRIPTION AS TYPE_DESCRIPTION, VT.TYPE AS TYPE_TYPE,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
  COALESCE(VM.USED_AMOUNT,0) AS USED_AMOUNT, V.AMOUNT - COALESCE(VM.USED_AMOUNT,0) AS OPEN_AMOUNT, (CASE WHEN VM.USED_AMOUNT = V.AMOUNT THEN 'Y' ELSE 'N' END) AS CLOSED
  FROM VOUCHER V
  LEFT OUTER JOIN VOUCHER_TYPE VT ON VT.ID_VOUCHER_TYPE = V.ID_TYPE
  LEFT OUTER JOIN KUPCI K ON K.ID = V.ID_LASTNIKA
  LEFT OUTER JOIN V_VOUCHER_MONEY VM ON VM.ID_VOUCHER = V.ID_VOUCHER
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1696, SYSDATE, '5.5', 1616, 'Vouchers')
;