DROP VIEW V_KNJIZBE_BREME
;

CREATE OR REPLACE VIEW V_KNJIZBE_BREME AS (
select MIN(k.CTRL) AS ID, MIN(K.ID_SALDKONT) AS ID_SALDKONT, S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, M.ID_CARDS, S.SDK_RN_TIP, SUM(K.BZNESEK*M.ZNESEK_SIT/S.ZA_PLACILO) AS BREME, SUM(K.BZNESEKSIT*M.ZNESEK_SIT/S.ZA_PLACILO) AS BREMESIT 
from 
knjizbe k 
join saldkont s on k.id_saldkont=s.id_saldkont 
LEFT OUTER JOIN EXCHANGE E ON S.ID_EXCHANGE=E.ID
LEFT OUTER JOIN MONEY M ON E.ID=M.ID_MENJAVE
WHERE K.STRAN='B' AND K.TIPKNJ<>'Z' AND S.ID_EXCHANGE IS NOT NULL AND (S.SDK_RN_PL='P' OR (S.SDK_RN_PL='R' AND K.TIPKNJ='B')) AND s.r_export_nr is null AND S.ZA_PLACILO<>0
GROUP BY S.ID_SALDKONT, S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, M.ID_CARDS, S.SDK_RN_TIP
UNION ALL
select MIN(k.CTRL) AS ID, MIN(K.ID_SALDKONT) AS ID_SALDKONT, S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, NULL, S.SDK_RN_TIP, SUM(K.BZNESEK) AS BREME, SUM(K.BZNESEKSIT) AS BREMESIT 
from 
knjizbe k 
join saldkont s on k.id_saldkont=s.id_saldkont 
WHERE K.STRAN='B' AND K.TIPKNJ<>'Z' AND (S.ID_EXCHANGE IS NULL  OR (S.SDK_RN_PL = 'R' AND K.TIPKNJ<>'B')) AND s.r_export_nr is null 
GROUP BY S.ID_SALDKONT, S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, S.SDK_RN_TIP
UNION ALL
select MIN(k.CTRL) AS ID, MIN(K.ID_SALDKONT) AS ID_SALDKONT, S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, NULL, S.SDK_RN_TIP, SUM(K.BZNESEK) AS BREME, SUM(K.BZNESEKSIT) AS BREMESIT 
from 
knjizbe k 
join saldkont s on k.id_saldkont=s.id_saldkont 
join saldkont_zap sz on k.idmaster=sz.id_saldkont_zap
WHERE K.STRAN='B' AND K.TIPKNJ='Z' AND sz.r_export_nr is null 
GROUP BY S.ID_SALDKONT, S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, S.SDK_RN_TIP
)
;

DROP VIEW V_KNJIZBE_DOBRO
;

CREATE OR REPLACE VIEW V_KNJIZBE_DOBRO AS (
select MIN(k.CTRL) AS ID, MIN(K.ID_SALDKONT) AS ID_SALDKONT, S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, M.ID_CARDS, S.SDK_RN_TIP, SUM(K.DZNESEK*M.ZNESEK_SIT/S.ZA_PLACILO) AS DOBRO, SUM(K.DZNESEKSIT*M.ZNESEK_SIT/S.ZA_PLACILO) AS DOBROSIT 
from 
knjizbe k 
join saldkont s on k.id_saldkont=s.id_saldkont 
LEFT OUTER JOIN EXCHANGE E ON S.ID_EXCHANGE=E.ID
LEFT OUTER JOIN MONEY M ON E.ID=M.ID_MENJAVE
WHERE K.STRAN='D' AND K.TIPKNJ<>'Z' AND S.ID_EXCHANGE IS NOT NULL AND (S.SDK_RN_PL='P' OR (S.SDK_RN_PL='R' AND K.TIPKNJ='B')) AND s.r_export_nr is null  AND S.ZA_PLACILO<>0
GROUP BY S.ID_SALDKONT, S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, M.ID_CARDS, S.SDK_RN_TIP
UNION ALL
select MIN(k.CTRL) AS ID, MIN(K.ID_SALDKONT) AS ID_SALDKONT, S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, NULL, S.SDK_RN_TIP, SUM(K.DZNESEK) AS DOBRO, SUM(K.DZNESEKSIT) AS DOBROSIT 
from 
knjizbe k 
join saldkont s on k.id_saldkont=s.id_saldkont 
WHERE K.STRAN='D' AND K.TIPKNJ<>'Z' AND (S.ID_EXCHANGE IS NULL OR (S.SDK_RN_PL = 'R' AND K.TIPKNJ<>'B')) AND s.r_export_nr is null 
GROUP BY S.ID_SALDKONT, S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, S.SDK_RN_TIP
UNION ALL
select MIN(k.CTRL) AS ID, MIN(K.ID_SALDKONT) AS ID_SALDKONT, S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, NULL, S.SDK_RN_TIP, SUM(K.DZNESEK) AS DOBRO, SUM(K.DZNESEKSIT) AS DOBROSIT 
from 
knjizbe k 
join saldkont s on k.id_saldkont=s.id_saldkont 
join saldkont_zap sz on k.idmaster=sz.id_saldkont_zap
WHERE K.STRAN='D' AND K.TIPKNJ='Z' AND sz.r_export_nr is null 
GROUP BY S.ID_SALDKONT, S.NNLOCATION_ID, K.DATUMV, K.DATUMK, K.KONTO, K.TIPKNJ, K.RAZMEJITEV, S.VRSTA_RACUNA, S.SDK_RN_TIP
)
;


insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1905, SYSDATE, '5.5', 1825, 'V_KNJIZBE')
;
