DROP VIEW V_PLOVILA_SALDAKONTI;

CREATE OR REPLACE VIEW V_PLOVILA_SALDAKONTI AS (
SELECT CONCAT(CONCAT(P.ID, CASE WHEN N.ID IS NULL THEN '' ELSE '-' END), N.ID) AS V_PLOVILA_SALDAKONTI_ID, P.ID AS PLOVILA_ID, K.ID AS KUPCI_ID, N.ID AS NNFIRMA_ID, N.FIRMA AS NNFIRMA_FIRMA, K.VALUTA_PLACILA,
  (CASE WHEN K.VALUTA_PLACILA IS NULL OR K.VALUTA_PLACILA = (SELECT DOMACAVALUTA FROM PARAM) THEN 'Y' ELSE 'N' END) AS KUPCI_DOMACA_VALUTA, P.IME AS PLOVILA_IME, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK,
  
  -- Saldo, domaca valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0')
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0')
  ) AS SALDAKONTI_SIT,
  
  -- Saldo brez depozitov, domaca valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0'
    AND S.ID_SALDKONT NOT IN (
      SELECT S2.ID_SALDKONT FROM SALDKONT S2 WHERE S2.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S2.NNFIRMA_ID)
      AND S2.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S2.SDK_RN_TIP) = 'I' AND UPPER(S2.SDK_RN_PL) = 'P' AND S2.ZAPRTO = '0' AND TRUNC(S2.DATUM) <= TRUNC(SYSDATE)
      AND S2.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
      ) 
    )
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0'
    AND S.ID_SALDKONT NOT IN (
      SELECT S2.ID_SALDKONT FROM SALDKONT S2 WHERE S2.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S2.NNFIRMA_ID)
      AND S2.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S2.SDK_RN_TIP) = 'I' AND UPPER(S2.SDK_RN_PL) = 'P' AND S2.ZAPRTO = '0' AND TRUNC(S2.DATUM) <= TRUNC(SYSDATE)
      AND S2.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
      ) 
    )
  ) AS SALDAKONTI_SIT_NO_DEPOSIT,
  
  -- Saldo, tuja valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN <> (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0')
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN <> (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0')
  ) AS SALDAKONTI_DEM,
  
  -- Saldo brez depozitov, tuja valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN <> (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0'
    AND S.ID_SALDKONT NOT IN (
      SELECT S2.ID_SALDKONT FROM SALDKONT S2 WHERE S2.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S2.NNFIRMA_ID)
      AND S2.VALUTA_RN <> (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S2.SDK_RN_TIP) = 'I' AND UPPER(S2.SDK_RN_PL) = 'P' AND S2.ZAPRTO = '0' AND TRUNC(S2.DATUM) <= TRUNC(SYSDATE)
      AND S2.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
      ) 
    ) 
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN <> (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0'
    AND S.ID_SALDKONT NOT IN (
      SELECT S2.ID_SALDKONT FROM SALDKONT S2 WHERE S2.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S2.NNFIRMA_ID)
      AND S2.VALUTA_RN <> (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S2.SDK_RN_TIP) = 'I' AND UPPER(S2.SDK_RN_PL) = 'P' AND S2.ZAPRTO = '0' AND TRUNC(S2.DATUM) <= TRUNC(SYSDATE)
      AND S2.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
      ) 
    ) 
  ) AS SALDAKONTI_DEM_NO_DEPOSIT,
  
  -- Saldo odprti, domaca valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE))
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE))
  ) AS SALDAKONTI_OUTSTANDING_SIT,
  
  -- Saldo odprti brez depozitov, domaca valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE)
     AND S.ID_SALDKONT NOT IN (
      SELECT S2.ID_SALDKONT FROM SALDKONT S2 WHERE S2.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S2.NNFIRMA_ID)
      AND S2.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S2.SDK_RN_TIP) = 'I' AND UPPER(S2.SDK_RN_PL) = 'P' AND S2.ZAPRTO = '0' AND TRUNC(S2.DATUM) <= TRUNC(SYSDATE)
      AND S2.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
      ) 
    )
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE)
      AND S.ID_SALDKONT NOT IN (
      SELECT S2.ID_SALDKONT FROM SALDKONT S2 WHERE S2.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S2.NNFIRMA_ID)
      AND S2.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S2.SDK_RN_TIP) = 'I' AND UPPER(S2.SDK_RN_PL) = 'P' AND S2.ZAPRTO = '0' AND TRUNC(S2.DATUM) <= TRUNC(SYSDATE)
      AND S2.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
      ) 
    )
  ) AS SALDAKONTI_OUT_SIT_NO_DEPOSIT, 
  
  -- Saldo odprti, tuja valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN <> (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE))
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN <> (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE))
  ) AS SALDAKONTI_OUTSTANDING_DEM,
  
  -- Saldo odprti brez depozitov, tuja valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN <> (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE)
    AND S.ID_SALDKONT NOT IN (
      SELECT S2.ID_SALDKONT FROM SALDKONT S2 WHERE S2.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S2.NNFIRMA_ID)
      AND S2.VALUTA_RN <> (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S2.SDK_RN_TIP) = 'I' AND UPPER(S2.SDK_RN_PL) = 'P' AND S2.ZAPRTO = '0' AND TRUNC(S2.DATUM) <= TRUNC(SYSDATE)
      AND S2.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
      ) 
    ) 
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN <> (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE)
    AND S.ID_SALDKONT NOT IN (
      SELECT S2.ID_SALDKONT FROM SALDKONT S2 WHERE S2.ID_PLOVILA = P.ID AND (N.ID IS NULL OR N.ID = S2.NNFIRMA_ID)
      AND S2.VALUTA_RN <> (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S2.SDK_RN_TIP) = 'I' AND UPPER(S2.SDK_RN_PL) = 'P' AND S2.ZAPRTO = '0' AND TRUNC(S2.DATUM) <= TRUNC(SYSDATE)
      AND S2.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
      ) 
    ) 
  ) AS SALDAKONTI_OUT_DEM_NO_DEPOSIT
FROM PLOVILA P JOIN KUPCI K ON P.ID_LASTNIKA=K.ID, V_NNFIRMA_ID_OR_NULL N
)
;

DROP VIEW V_PLOVILA_BALANCE;

CREATE OR REPLACE VIEW V_PLOVILA_BALANCE AS (
  SELECT VPS.V_PLOVILA_SALDAKONTI_ID AS V_PLOVILA_BALANCE_ID, VPS.PLOVILA_ID, VPS.KUPCI_ID, VPS.NNFIRMA_ID, VPS.NNFIRMA_FIRMA, VPS.PLOVILA_IME, VPS.KUPCI_IME, VPS.KUPCI_PRIIMEK, 
  
  -- Saldakonti sit
  CASE
    WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'ExcludeDepositsFromSaldo') = '1' THEN COALESCE(VPS.SALDAKONTI_SIT_NO_DEPOSIT, 0) ELSE COALESCE(VPS.SALDAKONTI_SIT, 0)
  END AS SALDAKONTI_SIT,
  
  -- Saldakonti dem
  CASE
    WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'ExcludeDepositsFromSaldo') = '1' THEN COALESCE(VPS.SALDAKONTI_DEM_NO_DEPOSIT, 0) ELSE COALESCE(VPS.SALDAKONTI_DEM, 0)
  END AS SALDAKONTI_DEM,
  
  -- Balance
  CASE 
    WHEN VPS.KUPCI_DOMACA_VALUTA = 'Y' THEN 
      (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'ExcludeDepositsFromSaldo') = '1' THEN COALESCE(VPS.SALDAKONTI_SIT_NO_DEPOSIT, 0) ELSE COALESCE(VPS.SALDAKONTI_SIT, 0) END)
    ELSE 
      (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'ExcludeDepositsFromSaldo') = '1' THEN COALESCE(VPS.SALDAKONTI_DEM_NO_DEPOSIT, 0) ELSE COALESCE(VPS.SALDAKONTI_DEM, 0) END)
  END AS BALANCE,
  
  -- Outstanding balance
  CASE 
    WHEN VPS.KUPCI_DOMACA_VALUTA = 'Y' THEN 
      (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'ExcludeDepositsFromSaldo') = '1' THEN COALESCE(VPS.SALDAKONTI_OUT_SIT_NO_DEPOSIT, 0) ELSE COALESCE(VPS.SALDAKONTI_OUTSTANDING_SIT, 0)  END)
    ELSE 
      (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'ExcludeDepositsFromSaldo') = '1' THEN COALESCE(VPS.SALDAKONTI_OUT_DEM_NO_DEPOSIT, 0) ELSE COALESCE(VPS.SALDAKONTI_OUTSTANDING_DEM, 0)  END)
    END AS OUTSTANDING_BALANCE
  
  FROM V_PLOVILA_SALDAKONTI VPS
)
;


insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2091, SYSDATE, '5.5', 2011, 'V_PLOVILA_BALANCE')
;
