ALTER TABLE SC_RESTYPE ADD ALLOWPROPS VARCHAR2(1);

UPDATE SC_RESTYPE SET ALLOWPROPS = 'T' WHERE ID <> 4 AND ALLOWPROPS IS NULL;

UPDATE SC_RESTYPE SET ALLOWPROPS = 'F' WHERE ID = 4 AND ALLOWPROPS IS NULL;

ALTER TABLE SC_RESTYPE MODIFY (ALLOWPROPS NOT NULL);

CREATE TABLE SC_RESOURCE (
  ID INTEGER NOT NULL,
  SC_RESTYPE_ID INTEGER NOT NULL,
  RESTYPECODE VARCHAR2(1) NOT NULL,
  NAME VARCHAR2(250),
  PLOVILA_ID INTEGER,
  KUPCI_ID INTEGER  
);

ALTER TABLE SC_RESOURCE ADD CONSTRAINT SC_RESOURCE_PK PRIMARY KEY (ID);

ALTER TABLE SC_RESOURCE ADD CONSTRAINT SC_RESOURCE_RESTYPE_FK FOREIGN KEY (SC_RESTYPE_ID) REFERENCES SC_RESTYPE (ID);

ALTER TABLE SC_RESOURCE ADD CONSTRAINT SC_RESOURCE_PLOVILA_FK FOREIGN KEY (PLOVILA_ID) REFERENCES PLOVILA (ID);

ALTER TABLE SC_RESOURCE ADD CONSTRAINT SC_RESOURCE_KUPCI_FK FOREIGN KEY (KUPCI_ID) REFERENCES KUPCI (ID);

CREATE SEQUENCE SC_RESOURCE_SEQ START WITH 1;

CREATE OR REPLACE VIEW V_KUPCI_PLOVILA AS (
  SELECT CONCAT(CONCAT(K.ID, '-'), P.ID) AS KUPCI_PLOVILA_ID, K.ID AS ID_LASTNIKA, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.NASLOV AS KUPCI_NASLOV, K.MESTO AS KUPCI_MESTO, K.POSTA AS KUPCI_POSTA, K.VRSTA AS KUPCI_VRSTA,
  K.NDRZAVA AS KUPCI_NDRZAVA, K.EMAIL AS KUPCI_EMAIL, K.TELEFON_1 AS KUPCI_TELEFON_1, K.YACHT_CLUB_ID, P.ID AS PLOVILA_ID, P.IME AS PLOVILA_IME, P.REGISTRSKA_N AS PLOVILA_REGISTRSKA_N, P.MODEL AS PLOVILA_MODEL,
  P.NTIP AS PLOVILA_NTIP, P.NZASTAVA AS PLOVILA_NZASTAVA, P.TRENUTNI_OBJEKT_PRIVEZA, P.TRENUTNA_N_PRIVEZA, P.TRENUTNO_DO, P.POGODBENI_OBJEKT_PRIVEZA, P.POGODBENA_N_PRIVEZA, P.POGODBA_DO, P.DOLZINA AS PLOVILA_DOLZINA,
  P.SIRINA AS PLOVILA_SIRINA, P.GREZ AS PLOVILA_GREZ, P.BOOKING AS PLOVILA_BOOKING
  FROM KUPCI K
  LEFT OUTER JOIN PLOVILA P ON P.ID_LASTNIKA = K.ID
);

insert into verzije_baza (id, dt_vpis, verzija, ver_nr, opis) 
values 
(452, SYSDATE, '5.5', 372, 'Sailing Training Centre');